local Skill_DB = {

--	[129] = { -- First Aid },	--  Not included in GetTradeSkillLineInfoByID()
--	[184] = { -- Cooking },		--  Not included in GetTradeSkillLineInfoByID()
--	[356] = { -- Fishing },		--  Not included in GetTradeSkillLineInfoByID()
--	[794] = { -- Archeology },	--  Not included in GetTradeSkillLineInfoByID()
--	[960] = { -- Runeforging },	--  Not included in GetTradeSkillLineInfoByID()

	[182] = { -- Herbalism
		2549, -- Zandalari Herbalism
		2550, -- Legion Herbalism
		2551, -- Draenor Herbalism
		2552, -- Pandaria Herbalism
		2553, -- Cataclysm Herbalism
		2554, -- Northrend Herbalism
		2555, -- Outland Herbalism
		2556, -- Herbalism
	},
	[186] = { -- Mining
		2565, -- Zandalari Mining
		2566, -- Legion Mining
		2567, -- Draenor Mining
		2568, -- Pandaria Mining
		2569, -- Cataclysm Mining
		2570, -- Northrend Mining
		2571, -- Outland Mining
		2572, -- Mining
	},
	[393] = { -- "Skinning"

		2557, -- Zandalari Skinning
		2558, -- Legion Skinning
		2559, -- Draenor Skinning
		2560, -- Pandaria Skinning
		2561, -- Cataclysm Skinning
		2562, -- Northrend Skinning
		2563, -- Outland Skinning
		2564, -- Skinning
	},
	[171] = { -- Alchemy
		2478, -- Zandalari Alchemy
		2479, -- Legion Alchemy
		2480, -- Draenor Alchemy
		2481, -- Pandaria Alchemy
		2482, -- Cataclysm Alchemy
		2483, -- Northrend Alchemy
		2484, -- Outland Alchemy
		2485, -- Alchemy
	},
	[164] = { -- Blacksmithing
		2437, -- Zandalari Blacksmithing
		2454, -- Legion Blacksmithing
		2472, -- Draenor Blacksmithing
		2473, -- Pandaria Blacksmithing
		2474, -- Cataclysm Blacksmithing
		2475, -- Northrend Blacksmithing
		2476, -- Outland Blacksmithing
		2477, -- Blacksmithing
	},
	[333] = { -- Enchanting
		2486, -- Zandalari Enchanting
		2487, -- Legion Enchanting
		2488, -- Draenor Enchanting
		2489, -- Pandaria Enchanting
		2491, -- Cataclysm Enchanting
		2492, -- Northrend Enchanting
		2493, -- Outland Enchanting
		2494, -- Enchanting
	},
	[202] = { -- Engineering
		2499, -- Zandalari Engineering
		2500, -- Legion Engineering
		2501, -- Draenor Engineering
		2502, -- Pandaria Engineering
		2503, -- Cataclysm Engineering
		2504, -- Northrend Engineering
		2505, -- Outland Engineering
		2506, -- Engineering
	},
	[773] = { -- Inscription
		2507, -- Zandalari Inscription
		2508, -- Legion Inscription
		2509, -- Draenor Inscription
		2510, -- Pandaria Inscription
		2511, -- Cataclysm Inscription
		2512, -- Northrend Inscription
		2513, -- Outland Inscription
		2514, -- Inscription
	},
	[755] = { -- Jewelcrafting
		2517, -- Zandalari Jewelcrafting
		2518, -- Legion Jewelcrafting
		2519, -- Draenor Jewelcrafting
		2520, -- Pandaria Jewelcrafting
		2521, -- Cataclysm Jewelcrafting
		2522, -- Northrend Jewelcrafting
		2523, -- Outland Jewelcrafting
		2524, -- Jewelcrafting
	},
	[165] = { -- Leatherworking
		2525, -- Zandalari Leatherworking
		2526, -- Legion Leatherworking
		2527, -- Draenor Leatherworking
		2528, -- Pandaria Leatherworking
		2529, -- Cataclysm Leatherworking
		2530, -- Northrend Leatherworking
		2531, -- Outland Leatherworking
		2532, -- Leatherworking
	},
	[197] = { -- Tailoring
		2533, -- Zandalari Tailoring
		2534, -- Legion Tailoring
		2535, -- Draenor Tailoring
		2536, -- Pandaria Tailoring
		2537, -- Cataclysm Tailoring
		2538, -- Northrend Tailoring
		2539, -- Outland Tailoring
		2540, -- Tailoring
	}
}

----------------------------------------------------------------------------------------------------
local	ADDON, ns = ...
local	AddonName = GetAddOnMetadata(ADDON, "Title") or ADDON
local	LDB = LibStub:GetLibrary("LibDataBroker-1.1")

----------------------------------------------------------------------------------------------------

local	AddonFrame = CreateFrame("Frame");
	AddonFrame : RegisterEvent("PLAYER_ENTERING_WORLD")
	AddonFrame : RegisterEvent("CHAT_MSG_SKILL")
	AddonFrame : RegisterEvent("TRAINER_UPDATE")

local	function Create_LDB()
		for _, index in pairs({GetProfessions()}) do
			if index == nil then return end
--			print (AddonName)
		local name, texture, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset, skillLineName = GetProfessionInfo(index);

			_G["BFA - " .. name] = LDB:NewDataObject( "BFA - " .. name .. skillLine , {type = "data source", text = " (" .. skillLevel .. "/" .. maxSkillLevel .. ") " or 0, icon = texture or "", label = "BFA - " .. name} )

			if (skillLine == 129) or (skillLine == 185) or (skillLine == 356) or (skillLine == 794) or (skillLine == 960) then print ("|cff0080FF " .. name .. "|r Tooltip |cffff3333 Not Supported|r") 
			
			else 
	
				_G["BFA - " .. name].OnTooltipShow =	function(self)
					name, _, skillLevel, maxSkillLevel, _, _, skillLine= GetProfessionInfo(index);
					self:AddLine	("|cffff3333BFA |cff0080FF ".. name .." |r:")

					if Skill_DB[skillLine] then 

						for i=1 , #Skill_DB[skillLine] , 1 
							
							do
		
							skillLineID = (Skill_DB[skillLine][i])
					
							local DisplayName, Rank, MaxRank, _, ParentID = C_TradeSkillUI.GetTradeSkillLineInfoByID(skillLineID)
							if MaxRank == 0 then MaxRank = "|cffff3333Need to Train|r" end
							--if ParentID == skillLine then 
								self:AddDoubleLine(DisplayName .. ": ", Rank .. " / |cff009900" .. MaxRank .." |r",nil,nil,nil,1,1,1)
							--end 
						end

					end
					self:AddLine	("  ")
					self:AddLine	("Left Click |cff009900 To Open |cff0080FF ".. name .." |r")

				end
				
			end 
			_G["BFA - " .. name].OnClick = function(self, button, down)


			name, _, skillLevel, maxSkillLevel, _, _, skill_Line= GetProfessionInfo(index);

					if skill_Line == 185 then CastSpellByName('Cooking') end
					if skill_Line == 794 then CastSpellByName('Archaeology') end
					if skill_Line == 186 then CastSpellByName('Mining Skills') end
					if skill_Line == 182 then CastSpellByName('Herbalism Skills') end
					if skill_Line == 171 then CastSpellByName('Alchemy') end
					if skill_Line == 164 then CastSpellByName('Blacksmithing') end
					if skill_Line == 333 then CastSpellByName('Enchanting') end 
					if skill_Line == 202 then CastSpellByName('Engineering') end 
					if skill_Line == 773 then CastSpellByName('Inscription') end 
					if skill_Line == 755 then CastSpellByName('Jewelcrafting') end 
					if skill_Line == 165 then CastSpellByName('Leatherworking') end 
					if skill_Line == 197 then CastSpellByName('Tailoring') end 
			end
		end
end

	AddonFrame : SetScript("OnEvent", function(self, event, arg1)

	if event == "PLAYER_ENTERING_WORLD" then
		Create_LDB()
		AddonFrame : UnregisterEvent("PLAYER_ENTERING_WORLD")
	end

	if event == "CHAT_MSG_SKILL" then
		for _, index in pairs({GetProfessions()}) do
			if index == nil then return end
			local name, _, skillLevel, maxSkillLevel = GetProfessionInfo(index);
			_G["BFA - " .. name].text = skillLevel
		end
	end
end)


